<template>
  <div class="the-configurator overflow-hidden fixed z-1 inset-0" @click="closeTheConfigurator">
    <div ref="configuratorWrapper" class="flex h-full justify-center items-center">
      <div
        id="theConfiguratorContent"
        ref="configuratorContent"
        class="the-configurator__content xs:overflow-auto animated-modal xs:fixed bottom-0 left-0 xs:w-full bg-bgdsec p-8 xs:px-4 xs:pt-4 rounded-32 xs:rounded-t-32 xs:rounded-b-none"
      >
        <keep-alive>
          <component
            :is="currentComponent"
            :form="form"
            @update-value="handleUpdateValue"
            @update-component="handleUpdateComponent"
          />
        </keep-alive>
      </div>
    </div>
  </div>
</template>

<script>
import CreateEndpoint from '@/components/the-configurator/CreateEndpoint.vue';
import CheckoutEndpoint from '@/components/the-configurator/CheckoutEndpoint.vue';

export default {
  name: 'TheConfigurator',

  components: { CreateEndpoint, CheckoutEndpoint },

  data() {
    return {
      form: {},

      currentComponent: 'CreateEndpoint',
    };
  },

  computed: {
    isOpened() {
      return this.$store.state.system.theConfiguratorDisplay;
    },
  },

  watch: {
    isOpened(value) {
      if (value) this.currentComponent = 'CreateEndpoint';
    },
  },

  methods: {
    closeTheConfigurator(event) {
      if (event.target === this.$refs.configuratorWrapper) this.$store.commit('setTheConfiguratorDisplay', false);
    },

    handleUpdateValue(value) {
      this.form = { ...this.form, ...value };
    },

    handleUpdateComponent(value) {
      this.currentComponent = value;
    },
  },
};
</script>

<style lang="scss">
.the-configurator {
  background: rgba(12, 21, 33, 0.64);

  &__content {
    width: 500px;

    @media (max-width: 600px) {
      max-height: calc(100vh - 120px);
    }
  }
}
</style>
